// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package templates

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetTemplatesParams creates a new GetTemplatesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetTemplatesParams() *GetTemplatesParams {
	return &GetTemplatesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetTemplatesParamsWithTimeout creates a new GetTemplatesParams object
// with the ability to set a timeout on a request.
func NewGetTemplatesParamsWithTimeout(timeout time.Duration) *GetTemplatesParams {
	return &GetTemplatesParams{
		timeout: timeout,
	}
}

// NewGetTemplatesParamsWithContext creates a new GetTemplatesParams object
// with the ability to set a context for a request.
func NewGetTemplatesParamsWithContext(ctx context.Context) *GetTemplatesParams {
	return &GetTemplatesParams{
		Context: ctx,
	}
}

// NewGetTemplatesParamsWithHTTPClient creates a new GetTemplatesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetTemplatesParamsWithHTTPClient(client *http.Client) *GetTemplatesParams {
	return &GetTemplatesParams{
		HTTPClient: client,
	}
}

/*
GetTemplatesParams contains all the parameters to send to the API endpoint

	for the get templates operation.

	Typically these are written to a http.Request.
*/
type GetTemplatesParams struct {

	/* Active.

	   Retrieve active records only?
	*/
	Active *bool

	/* IsMaster.

	   Is Master Template?
	*/
	IsMaster *bool

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* ObjectType.

	   Object Type Name
	*/
	ObjectType *string

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	/* TemplateID.

	   Template ID
	*/
	TemplateID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get templates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTemplatesParams) WithDefaults() *GetTemplatesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get templates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTemplatesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get templates params
func (o *GetTemplatesParams) WithTimeout(timeout time.Duration) *GetTemplatesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get templates params
func (o *GetTemplatesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get templates params
func (o *GetTemplatesParams) WithContext(ctx context.Context) *GetTemplatesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get templates params
func (o *GetTemplatesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get templates params
func (o *GetTemplatesParams) WithHTTPClient(client *http.Client) *GetTemplatesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get templates params
func (o *GetTemplatesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get templates params
func (o *GetTemplatesParams) WithActive(active *bool) *GetTemplatesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get templates params
func (o *GetTemplatesParams) SetActive(active *bool) {
	o.Active = active
}

// WithIsMaster adds the isMaster to the get templates params
func (o *GetTemplatesParams) WithIsMaster(isMaster *bool) *GetTemplatesParams {
	o.SetIsMaster(isMaster)
	return o
}

// SetIsMaster adds the isMaster to the get templates params
func (o *GetTemplatesParams) SetIsMaster(isMaster *bool) {
	o.IsMaster = isMaster
}

// WithLimit adds the limit to the get templates params
func (o *GetTemplatesParams) WithLimit(limit *int64) *GetTemplatesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get templates params
func (o *GetTemplatesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithObjectType adds the objectType to the get templates params
func (o *GetTemplatesParams) WithObjectType(objectType *string) *GetTemplatesParams {
	o.SetObjectType(objectType)
	return o
}

// SetObjectType adds the objectType to the get templates params
func (o *GetTemplatesParams) SetObjectType(objectType *string) {
	o.ObjectType = objectType
}

// WithOffset adds the offset to the get templates params
func (o *GetTemplatesParams) WithOffset(offset *int64) *GetTemplatesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get templates params
func (o *GetTemplatesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithTemplateID adds the templateID to the get templates params
func (o *GetTemplatesParams) WithTemplateID(templateID *string) *GetTemplatesParams {
	o.SetTemplateID(templateID)
	return o
}

// SetTemplateID adds the templateId to the get templates params
func (o *GetTemplatesParams) SetTemplateID(templateID *string) {
	o.TemplateID = templateID
}

// WriteToRequest writes these params to a swagger request
func (o *GetTemplatesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.IsMaster != nil {

		// query param isMaster
		var qrIsMaster bool

		if o.IsMaster != nil {
			qrIsMaster = *o.IsMaster
		}
		qIsMaster := swag.FormatBool(qrIsMaster)
		if qIsMaster != "" {

			if err := r.SetQueryParam("isMaster", qIsMaster); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.ObjectType != nil {

		// query param objectType
		var qrObjectType string

		if o.ObjectType != nil {
			qrObjectType = *o.ObjectType
		}
		qObjectType := qrObjectType
		if qObjectType != "" {

			if err := r.SetQueryParam("objectType", qObjectType); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.TemplateID != nil {

		// query param templateId
		var qrTemplateID string

		if o.TemplateID != nil {
			qrTemplateID = *o.TemplateID
		}
		qTemplateID := qrTemplateID
		if qTemplateID != "" {

			if err := r.SetQueryParam("templateId", qTemplateID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
