// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package prompts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// NewPutPromptsParams creates a new PutPromptsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutPromptsParams() *PutPromptsParams {
	return &PutPromptsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutPromptsParamsWithTimeout creates a new PutPromptsParams object
// with the ability to set a timeout on a request.
func NewPutPromptsParamsWithTimeout(timeout time.Duration) *PutPromptsParams {
	return &PutPromptsParams{
		timeout: timeout,
	}
}

// NewPutPromptsParamsWithContext creates a new PutPromptsParams object
// with the ability to set a context for a request.
func NewPutPromptsParamsWithContext(ctx context.Context) *PutPromptsParams {
	return &PutPromptsParams{
		Context: ctx,
	}
}

// NewPutPromptsParamsWithHTTPClient creates a new PutPromptsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutPromptsParamsWithHTTPClient(client *http.Client) *PutPromptsParams {
	return &PutPromptsParams{
		HTTPClient: client,
	}
}

/*
PutPromptsParams contains all the parameters to send to the API endpoint

	for the put prompts operation.

	Typically these are written to a http.Request.
*/
type PutPromptsParams struct {

	/* PromptRequest.

	   An array of new Prompt records
	*/
	PromptRequest *sfgate_models.PromptRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put prompts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutPromptsParams) WithDefaults() *PutPromptsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put prompts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutPromptsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put prompts params
func (o *PutPromptsParams) WithTimeout(timeout time.Duration) *PutPromptsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put prompts params
func (o *PutPromptsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put prompts params
func (o *PutPromptsParams) WithContext(ctx context.Context) *PutPromptsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put prompts params
func (o *PutPromptsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put prompts params
func (o *PutPromptsParams) WithHTTPClient(client *http.Client) *PutPromptsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put prompts params
func (o *PutPromptsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPromptRequest adds the promptRequest to the put prompts params
func (o *PutPromptsParams) WithPromptRequest(promptRequest *sfgate_models.PromptRequest) *PutPromptsParams {
	o.SetPromptRequest(promptRequest)
	return o
}

// SetPromptRequest adds the promptRequest to the put prompts params
func (o *PutPromptsParams) SetPromptRequest(promptRequest *sfgate_models.PromptRequest) {
	o.PromptRequest = promptRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutPromptsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PromptRequest != nil {
		if err := r.SetBodyParam(o.PromptRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
