// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package sfgate_models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// CompanyService A service performed by a Company
//
// swagger:model CompanyService
type CompanyService struct {

	// ID of the Company that owns this Service
	AccountID string `json:"AccountID,omitempty"`

	// Salesforce AppExchange URL
	AppExchange *string `json:"AppExchange,omitempty"`

	// Created By User ID
	CreatedByID *string `json:"CreatedByID,omitempty"`

	// Created Date
	CreatedDate *string `json:"CreatedDate,omitempty"`

	// Description of service
	Description *string `json:"Description,omitempty"`

	// Full Description of service
	FullDescription *string `json:"FullDescription,omitempty"`

	// Record Id
	ID string `json:"ID,omitempty"`

	// Image Alt Text
	ImageAltText *string `json:"ImageAltText,omitempty"`

	// Image URL
	ImageURL *string `json:"ImageURL,omitempty"`

	// Industries
	Industries []*Industry `json:"Industries"`

	// Last Modified By User ID
	LastModifiedByID *string `json:"LastModifiedByID,omitempty"`

	// Last Modified Date
	LastModifiedDate *string `json:"LastModifiedDate,omitempty"`

	// Logo
	Logo *string `json:"Logo,omitempty"`

	// Service Name
	Name *string `json:"Name,omitempty"`

	// Published
	Published *bool `json:"Published,omitempty"`

	// Salesforce Specific
	SalesforceSpecific *bool `json:"SalesforceSpecific,omitempty"`

	// Service Video ID
	ServiceVideoID *string `json:"ServiceVideoID,omitempty"`

	// Slug
	Slug *string `json:"Slug,omitempty"`

	// Tag Line
	TagLine *string `json:"TagLine,omitempty"`

	// URL
	URL *string `json:"URL,omitempty"`
}

// Validate validates this company service
func (m *CompanyService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateIndustries(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *CompanyService) validateIndustries(formats strfmt.Registry) error {
	if swag.IsZero(m.Industries) { // not required
		return nil
	}

	for i := 0; i < len(m.Industries); i++ {
		if swag.IsZero(m.Industries[i]) { // not required
			continue
		}

		if m.Industries[i] != nil {
			if err := m.Industries[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("Industries" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("Industries" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this company service based on the context it is used
func (m *CompanyService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIndustries(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *CompanyService) contextValidateIndustries(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Industries); i++ {

		if m.Industries[i] != nil {
			if err := m.Industries[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("Industries" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("Industries" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *CompanyService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *CompanyService) UnmarshalBinary(b []byte) error {
	var res CompanyService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
